'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StickyTree = function (_React$Component) {
    _inherits(StickyTree, _React$Component);

    function StickyTree(props) {
        _classCallCheck(this, StickyTree);

        var _this = _possibleConstructorReturn(this, (StickyTree.__proto__ || Object.getPrototypeOf(StickyTree)).call(this, props));

        _this.onScroll = _this.onScroll.bind(_this);

        _this.state = {
            scrollTop: 0,
            currNodePos: 0
        };

        console.time('flatten');
        var innerScrollHeight = _this.calculateHeight(_this.props.tree.root);
        var nodes = [{ id: 'root', top: 0, node: _this.props.tree.root, index: 0, height: innerScrollHeight, children: [] }];
        _this.nodePosCache = _this.flattenTree(_this.props.tree, _this.props.tree.root, nodes);
        console.timeEnd('flatten');
        console.info(_this.nodePosCache);
        return _this;
    }

    _createClass(StickyTree, [{
        key: 'flattenTree',
        value: function () {
            function flattenTree(tree, parent) {
                var nodes = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
                var params = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : { totalHeight: 0 };

                var parentIndex = nodes.length - 1;
                for (var i = 0; i < parent.children.length; i++) {
                    var child = tree[parent.children[i]];
                    var childInfo = { id: child.id, top: params.totalHeight, parentIndex: parentIndex, index: nodes.length, children: [] };
                    params.totalHeight += this.props.getHeight(child.id);

                    nodes.push(childInfo);
                    nodes[parentIndex].children.push(childInfo.index);

                    if (child.children.length > 0) {
                        this.flattenTree(tree, child, nodes, params);
                    }
                    childInfo.height = params.totalHeight - childInfo.top;
                }
                return nodes;
            }

            return flattenTree;
        }()
    }, {
        key: 'shouldComponentUpdate',
        value: function () {
            function shouldComponentUpdate(newProps, newState) {
                return this.state.currNodePos !== newState.currNodePos || this.props.width !== newProps.width || this.props.height !== newProps.height || this.props.tree !== newProps.tree;
            }

            return shouldComponentUpdate;
        }()
    }, {
        key: 'componentWillReceiveProps',
        value: function () {
            function componentWillReceiveProps(newProps) {
                if (newProps.tree !== this.props.tree) {
                    console.info('new Tree');
                }
            }

            return componentWillReceiveProps;
        }()
    }, {
        key: 'calculateHeight',
        value: function () {
            function calculateHeight(parent) {
                var _this2 = this;

                var height = 0;
                parent.children.forEach(function (id) {
                    height += _this2.props.getHeight(parent.id);
                    if (_this2.props.tree[id].children.length > 0) {
                        height += _this2.calculateHeight(_this2.props.tree[id]);
                    }
                });

                return height;
            }

            return calculateHeight;
        }()
    }, {
        key: 'getChildContainerStyle',
        value: function () {
            function getChildContainerStyle(child, top) {
                return { position: 'absolute', top: top, height: child.height, width: '100%' };
            }

            return getChildContainerStyle;
        }()
    }, {
        key: 'renderParentTree',
        value: function () {
            function renderParentTree() {
                var rowRenderRange = this.getRenderRowRange();
                var path = this.getParentPath(rowRenderRange.start);

                var indexesToRender = new Set();
                for (var i = 0; i < path.length; i++) {
                    indexesToRender.add(path[i].index);
                }
                for (var _i = rowRenderRange.start; _i <= rowRenderRange.end; _i++) {
                    indexesToRender.add(this.nodePosCache[_i].index);
                }
                if (this.props.renderRoot) {
                    return _react2['default'].createElement(
                        'ul',
                        { className: 'sticky-tree-list' },
                        this.renderChildWithChildren(path[0], 0, indexesToRender)
                    );
                }
                return this.renderParentContainer(path[0], 'sticky-tree-list', indexesToRender);
            }

            return renderParentTree;
        }()
    }, {
        key: 'renderParentContainer',
        value: function () {
            function renderParentContainer(parent, className, indexesToRender) {
                return _react2['default'].createElement(
                    'ul',
                    { key: parent.id, className: className, style: { position: 'absolute', width: '100%' } },
                    this.renderChildren(parent, indexesToRender)
                );
            }

            return renderParentContainer;
        }()
    }, {
        key: 'renderChildWithChildren',
        value: function () {
            function renderChildWithChildren(child, top, indexesToRender) {
                return _react2['default'].createElement(
                    'li',
                    { key: child.id, style: this.getChildContainerStyle(child, top) },
                    this.props.rowRenderer(child.id),
                    this.renderParentContainer(child, 'parent-node', indexesToRender)
                );
            }

            return renderChildWithChildren;
        }()
    }, {
        key: 'renderChildren',
        value: function () {
            function renderChildren(parent, indexesToRender) {
                var _this3 = this;

                var nodes = [];
                var top = 0;
                parent.children.forEach(function (index) {
                    var child = _this3.nodePosCache[index];

                    if (indexesToRender.has(index)) {
                        if (child.children && child.children.length > 0) {
                            nodes.push(_this3.renderChildWithChildren(child, top, indexesToRender));
                        } else {
                            nodes.push(_react2['default'].createElement(
                                'li',
                                { key: child.id, style: _this3.getChildContainerStyle(child, top) },
                                _this3.props.rowRenderer(child.id)
                            ));
                        }
                    }
                    // Needs to be on the outside so that we add the the top even if
                    // this node is not visible
                    top += child.height;
                });
                return nodes;
            }

            return renderChildren;
        }()
    }, {
        key: 'getRenderRowRange',
        value: function () {
            function getRenderRowRange() {
                var start = this.state.currNodePos - this.props.overscanRowCount;
                if (start < 0) {
                    start = 0;
                }
                var end = this.state.currNodePos + 1;

                while (this.nodePosCache[end] && this.nodePosCache[end].top < this.state.scrollTop + this.props.height) {
                    end++;
                }

                end = end + this.props.overscanRowCount;
                if (end > this.nodePosCache.length - 1) {
                    end = this.nodePosCache.length - 1;
                }

                return { start: start, end: end };
            }

            return getRenderRowRange;
        }()
    }, {
        key: 'getParentPath',
        value: function () {
            function getParentPath(nodeIndex) {
                var currNode = this.nodePosCache[nodeIndex];
                var path = [currNode];
                while (currNode) {
                    currNode = this.nodePosCache[currNode.parentIndex];
                    if (currNode) {
                        path.push(currNode);
                    }
                }
                return path.reverse();
            }

            return getParentPath;
        }()
    }, {
        key: 'forwardSearch',
        value: function () {
            function forwardSearch(scrollTop) {
                var nodePosCache = this.nodePosCache;
                for (var i = this.state.currNodePos; i < nodePosCache.length; i++) {
                    if (nodePosCache[i].top >= scrollTop) {
                        return i;
                    }
                }
                return nodePosCache.length - 1;
            }

            return forwardSearch;
        }()
    }, {
        key: 'backwardSearch',
        value: function () {
            function backwardSearch(scrollTop) {
                var nodePosCache = this.nodePosCache;
                for (var i = this.state.currNodePos; i >= 0; i--) {
                    if (nodePosCache[i].top <= scrollTop) {
                        return i;
                    }
                }
                return 0;
            }

            return backwardSearch;
        }()
    }, {
        key: 'findClosestNode',
        value: function () {
            function findClosestNode(scrollTop) {
                var pos = void 0;
                if (scrollTop > this.state.scrollTop) {
                    pos = this.forwardSearch(scrollTop);
                } else if (scrollTop < this.state.scrollTop) {
                    pos = this.backwardSearch(scrollTop);
                }
                if (pos !== this.state.currNodePos) {
                    this.setState({ currNodePos: pos });
                }
            }

            return findClosestNode;
        }()
    }, {
        key: 'onScroll',
        value: function () {
            function onScroll(e) {
                var scrollTop = e.target.scrollTop;
                this.findClosestNode(scrollTop);
                this.setState({ scrollTop: scrollTop });
            }

            return onScroll;
        }()
    }, {
        key: 'getStyle',
        value: function () {
            function getStyle() {
                var style = {};
                if (this.props.width) {
                    style.width = this.props.width;
                }
                if (this.props.height) {
                    style.height = this.props.height;
                }
                return style;
            }

            return getStyle;
        }()
    }, {
        key: 'render',
        value: function () {
            function render() {
                return _react2['default'].createElement(
                    'div',
                    { className: 'sticky-tree', style: this.getStyle(), onScroll: this.onScroll },
                    this.renderParentTree()
                );
            }

            return render;
        }()
    }]);

    return StickyTree;
}(_react2['default'].Component);

StickyTree.defaultProps = {
    overscanRowCount: 0,
    renderRoot: true
};
exports['default'] = StickyTree;